/*********************************************************************
*	AFEDRI SDR-Net Commander utility
*	Author: Alexander Trushkin ( 4Z5LV )
*	Date: 6.11.2013
*	
*	This utility allows you to control AFEDRI SDR 
*	over USB connection.
*	So you can use this utility in command shell scripts or WebSDR
*	or in crone command   
**********************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <malloc.h>
//#include <io.h>
//#include <conio.h>
#include <ctype.h>
#include "hidapi.h"
#include "fe_interface.h"
#include "commands.h"
#include "version.h"
#include "tcp_shell.h"

#ifndef TRUE
	#define TRUE 1
#endif
#ifndef FALSE
	#define FALSE 0
#endif
#define SIZE_OF_WCHAR_BUF 256
volatile int network_state = 0;

int main(int argc, char **argv)
{
int RF_Gain = 0;
int FE_Gain = 0;
int LNA_Gain = 0;
int MIX_Gain = 0;
unsigned long tmp = 0;
int error = 0;
int arg;
int device_init_state = 0;
char tmp_path_name[256];
char tmp_serial_number[256];
char sdr_ip_address[256];
wchar_t *serial = NULL;
int current_channel = 0;
int mult_mode = 0;
int arg_shift =2;
int agc_mode = 0;	
int led_off = 0;
int macw = 0;	
	
char *default_ip_address = "192.168.0.8";
unsigned short tcp_port = 50000;
#ifndef __linux__
//	wchar_t tmp_serial[SIZE_OF_WCHAR_BUF]=L"\0";
#endif
	//	memset(tmp_serial,0,sizeof(tmp_serial));
	printf("sdr_commander v.%s\n\r",APP_VERSION);
	MSD_Envy_Init();
	Set_USB_Serial_number((wchar_t*)NULL);
    memset(tmp_path_name,0, sizeof(tmp_path_name));
    memset(sdr_ip_address,0, sizeof(sdr_ip_address));
    memcpy(sdr_ip_address, default_ip_address, strlen(default_ip_address));
	if(argc > 1)
	{
		for(arg = 1; arg < argc;arg++)
		{
			if (argv[arg][0] == '-')
			{
				
				switch(toupper(argv[arg][1]))
				{					
					case 'L':				/* verbose */
						enumerate_afedri_devs();
						break;
					case 'P': // SDR disk drive path in MSD mode / SDR IP port in noetwork mode
//						printf("read path: ");
						sscanf(&argv[arg][2], "%s", tmp_path_name);
						if (tmp_path_name == 0)
						{
					 		printf("wrong path!\r\n");
						}
						else
						{
							SetMSDPath(tmp_path_name);
//							printf("%s %i \r\n",tmp_path_name, strlen(tmp_path_name));
						}
						break;
					case 'T': //SDR IP address
						sscanf(&argv[arg][2], "%s", sdr_ip_address);
						if (sdr_ip_address == 0)
						{
					 		printf("wrong ip address!\r\n");
						}
						else
						{
							network_state = 1;
						}
						break;
					case 'N':
						sscanf(&argv[arg][2], "%s", tmp_serial_number);
						if (tmp_serial_number == 0)
						{
					 		printf("No device serial number!\r\n");
							serial = NULL;
						}
						else
						{
	#ifdef __linux__
                            serial = (wchar_t *) memalign(sizeof(wchar_t), SIZE_OF_WCHAR_BUF);
                            mbstowcs (serial, tmp_serial_number, strlen(tmp_serial_number));
    #elif __APPLE__
							posix_memalign(&serial, sizeof(wchar_t), SIZE_OF_WCHAR_BUF);
							mbstowcs (serial, tmp_serial_number, strlen(tmp_serial_number));
	#else
							serial = (wchar_t *) __mingw_aligned_malloc(sizeof(wchar_t), SIZE_OF_WCHAR_BUF);
							mbstowcs (serial, tmp_serial_number, strlen(tmp_serial_number));
//							serial = tmp_serial;
	#endif
							serial[strlen(tmp_serial_number)] = L'\0';
							Set_USB_Serial_number(serial);
	#if defined ( __linux__ ) || defined (__APPLE__)
							free(serial);
	#else
							__mingw_aligned_free(serial);
	#endif
						}
						break;
				}
			}
		}
		if(network_state == 1)
		{
			if(isdigit(tmp_path_name[0] )) 	tcp_port = atoi(tmp_path_name);
			printf("SDR IP=%s:%u\r\n",sdr_ip_address,tcp_port);
			error = open_tcp_connection(sdr_ip_address, tcp_port);
		}
		else
		{
			error = initialize_hardware();
		}
		if(error < 0) 
		{
			printf("Cannot open AFEDRI SDR!\n\r");
//			device_init_state = 1;
			return -1;
		}

	}
	else
	{
		show_help_information();
		printf("Nothing To Do, please write the command to SDR! \n\r")	;
		return -2;
	}
	for (arg = 1; arg < argc; arg++)
	{
		if (argv[arg][0] == '-')
		{
			switch(toupper(argv[arg][1]))
			{
			case 'F':	/* set reception frequency */
//				if(device_init_state) break;
				if (sscanf(&argv[arg][2], "%ld", &tmp) != 1)
					error = TRUE;
				if (tmp == 0) error = TRUE;
				else set_rx_frequency(tmp, current_channel);
				break;
			case 'M':	/* save Main Clock frequency */
//				if(device_init_state) break;
				if (sscanf(&argv[arg][2], "%ld", &tmp) != 1)
					error = TRUE;
				if(tmp > 50000000) 	save_main_clock_freq(tmp);
				else printf("The Main Clock value is too low!\r\n");
				break;
			case 'S':	/* save USB sample rate */
//				if(device_init_state) break;
				if(toupper(argv[arg][2]) == 'D')
					arg_shift = 3;
				else if(toupper(argv[arg][2]) == 'N')
					arg_shift = 3;
				else arg_shift = 2;
				if (sscanf(&argv[arg][arg_shift], "%ld", &tmp) != 1)
					error = TRUE;
				if (tmp < 48000 )//|| tmp > 250000)
				{ 
					error = TRUE;
				}
				else
				{
					if(arg_shift == 2) save_usb_sample_rate(tmp);
					else if(arg_shift == 3)
					{
						if(toupper(argv[arg][2]) == 'N')
						{
							set_new_sample_rate(tmp);
							break;
						}
						else save_diversity_sample_rate(tmp);
					}
				}
			case 'R':	/* Soft Reset SDR */
//				if(device_init_state) break;
				reset_sdr();
				printf("Please Wait till SDR will be restarted again \n\r");
				return 0;
			case 'G': //Set RF gain			
				switch(argv[arg][2])
				{
					case 'l':
						if (sscanf(&argv[arg][3], "%d", &LNA_Gain) != 1)
							error = TRUE;
							set_r820t_lna_gain((unsigned char)LNA_Gain);	
					case 'm':
						if (sscanf(&argv[arg][3], "%d", &MIX_Gain) != 1)
							error = TRUE;
							set_r820t_mix_gain((unsigned char)MIX_Gain);	
					default:
						if (sscanf(&argv[arg][2], "%d", &RF_Gain) != 1)
						error = TRUE;
						set_rf_gain(RF_Gain,current_channel);
					}
				break;
			case 'I': //Set RF gain	indexed from 0 to 15
				switch(argv[arg][2])
				{
					case 'l':
						if (sscanf(&argv[arg][3], "%d", &LNA_Gain) != 1)
							error = TRUE;
							set_r820t_lna_gain((unsigned char)LNA_Gain);	
					case 'm':
						if (sscanf(&argv[arg][3], "%d", &MIX_Gain) != 1)
							error = TRUE;
							set_r820t_mix_gain((unsigned char)MIX_Gain);	
					default:
						if (sscanf(&argv[arg][2], "%d", &RF_Gain) != 1)
						error = TRUE;
						set_rf_gain(RF_Gain,current_channel);
					}
//				if(device_init_state) break;
				if (sscanf(&argv[arg][2], "%d", &RF_Gain) != 1)
					error = TRUE;
				set_rf_gain_indexed(RF_Gain,current_channel);
				break;
			case 'C': //Set Current Channel Number
				if (sscanf(&argv[arg][2], "%d", &current_channel) != 1)
					error = TRUE;
				break;
			case 'E': //Set FE gain			
//				if(device_init_state) break;
				if (sscanf(&argv[arg][2], "%d", &FE_Gain) != 1)
					error = TRUE;
				set_fe_gain(FE_Gain);
				break;
			case 'Q': //Set Multichannel mode
//				if(device_init_state) break;
				if (sscanf(&argv[arg][2], "%d", &mult_mode) != 1)
					error = TRUE;
				set_multichannel_mode(mult_mode,current_channel);
				break;
			case 'A': //Set AGC mode
				switch(argv[arg][2])
				{
					case '?':
						get_agc_level_state();
						break;
					case 'l':
						if (sscanf(&argv[arg][3], "%d", &agc_mode) != 1)
							error = TRUE;
							set_r820t_lna_agc_mode(agc_mode);	
					case 'm':
						if (sscanf(&argv[arg][3], "%d", &agc_mode) != 1)
							error = TRUE;
							set_r820t_mix_agc_mode(agc_mode);	
					default:
						if (sscanf(&argv[arg][2], "%d", &agc_mode) != 1)
							error = TRUE;
							set_agc_mode(agc_mode);
					}
				break;
			case 'J': //Set AGC mode
				switch(argv[arg][2])
				{
					case '?':
						get_mac_word();
						break;
					case 'l':
					default:
						if (sscanf(&argv[arg][2], "%x", &macw) != 1)
							error = TRUE;
							save_mac_word(macw);
							printf("The new MAC will be active after SDR reset: %X", macw);
				}
				break;
			case 'H':				/* help */
				show_help_information();
				break;

			case 'U': //Set USB mode for AFEDRI SDR-USB-HS
//				if(device_init_state) break;
				if (sscanf(&argv[arg][2], "%d", &tmp) != 1)
					error = TRUE;
				set_usb_mode(tmp);
				break;
			case 'B': //Set LED On/Off mode
				if (sscanf(&argv[arg][2], "%d", &led_off) != 1)
					error = TRUE;
				set_leds_on_off(led_off);
				break;
			case 'V':				/* verbose */
//				if(device_init_state) break;
				Get_SDR_Information();
				break;
			case 'D':				/* Save default settings */
//				if(device_init_state) break;
				save_defaults();
				break;
			case 'X': //Start/Stop data stream
				if (sscanf(&argv[arg][2], "%d", &tmp) != 1)
					error = TRUE;
				start_data_stream(tmp);
				break;

			default:
				break;
			}
		}
	}
	//if(device_init_state)
	HID_Close();
	return 0;
}
