#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <malloc.h>
 #ifdef _WIN32
    #include <windows.h>
	#include <winsock.h>
	#define INVSOCK INVALID_SOCKET
 #else
	#include <unistd.h>
	#include <sys/types.h>	
	#include <sys/stat.h>
	#include <sys/socket.h> 
	#include <arpa/inet.h>  
	#define INVSOCK -1
 #endif
#include "hidapi.h"
#include "fe_interface.h"
#include "net_commands.h"
#include "version.h"
#include "tcp_shell.h"

//extern
//static MainWindow    *w;
//static QTcpSocket *ptcpSocket;
#define RECV_FLAG 0

#ifdef _WIN32
	#define FD unsigned int
	#define CLOSE_FD closesocket
	WSADATA wsadata;
#else
	#define CLOSE_FD close
	#define FD int
#endif

char block[32]={0};
volatile int TCP_command_pending = 0;
//volatile int tcp_write_pending = 0;
FD sdr_fd;
struct sockaddr_in sdr_addr;

int open_tcp_connection(const unsigned char *ip, const int port)
{
int i, j;
//unsigned char *ip;
char s[80];
int optval = 0;
int optlen = sizeof(optval);
#ifdef _WIN32
if(WSAStartup(2, &wsadata) != 0)
  {
	fprintf(stderr,"Cannot start WSA interface\n\r");
	return -1;   
  }
#endif
memset(&sdr_addr, 0, sizeof(sdr_addr)); 
sdr_addr.sin_family=AF_INET;
sdr_addr.sin_port=htons(port);
if(ip != NULL)
	sdr_addr.sin_addr.s_addr = inet_addr(ip);
else
	sdr_addr.sin_addr.s_addr = inet_addr("192.168.0.8");
if ((sdr_fd = socket(AF_INET, SOCK_STREAM, 0)) == INVSOCK) 
{
	fprintf(stderr,"Cannot open  TCP socket\n\r");
	return -1;
}
   /* Check the status for the keepalive option */
if(getsockopt(sdr_fd, SOL_SOCKET, SO_KEEPALIVE, (char *)&optval, &optlen) < 0) 
{
      perror("getsockopt()");
}
printf("SO_KEEPALIVE is %s\n", (optval ? "ON" : "OFF"));
optval = 1;
if(setsockopt(sdr_fd, SOL_SOCKET, SO_KEEPALIVE, (char *)&optval, optlen) < 0) 
{
      perror("Cannot set keepalive otion!\n\r");
}
if(connect(sdr_fd, (struct sockaddr *)&sdr_addr, sizeof(sdr_addr)) < 0)
{
	fprintf(stderr,"Cannot connect to  SDR!\n\r");
	return -1;
}
hid_change_tcp_network_flag(1);
return 0;
}

void close_tcp()
{
	CLOSE_FD(sdr_fd);
}

int tcp_send_frequency(unsigned long frequency, int channel)
{
    unsigned short control_code = CI_FREQUENCY;
    int size = 10;
//    block.resize(10);
    block[0] = size;
    block[1] = (SET_CONTROL_ITEM << 5);
    block[2] = control_code & 0xFF;
    block[3] = (control_code >> 8) & 0xFF;
    block[4] = channel;
    for(int i = 0; i < 4; i++)
    {
        block[5+i] = (frequency >> (i*8)) & 0xFF;
    }
    block[9] = 0;
    return TCP_write(block, size);
}

int tcp_send_sample_rate(unsigned long sample_rate)
{
    unsigned short control_code = CI_DDC_SAMPLE_RATE;
    int size = 9;
    block[0] = size;
    block[1] = (SET_CONTROL_ITEM << 5);
    block[2] = control_code & 0xFF;
    block[3] = (control_code >> 8) & 0xFF;
    block[4] = 0;
    for(int i = 0; i <4; i++)
    {
        block[5+i] = (sample_rate >> (i*8)) & 0xFF;
    }
    return TCP_write(block, size);
}

    int tcp_set_udp_rx_state(unsigned char command)
{
    unsigned short control_code = CI_RECEIVER_STATE;
    int size = 8;
//    block.resize(8);
    block[0] = size;
    block[1] = (SET_CONTROL_ITEM << 5);
    block[2] = control_code & 0xFF;
    block[3] = (control_code >> 8) & 0xFF;
    block[4] = 0x80;
    block[5] = command;
    block[6] = 0;
    block[7] = 0;
    return TCP_write(block, size);
}

int tcp_set_rf_gain_state(int channel, char gain)
{
    unsigned short control_code = CI_RF_GAIN;
    int size = 6;
//    block.resize(6);
    block[0] =  size;
    block[1] = (SET_CONTROL_ITEM << 5);
    block[2] = control_code & 0xFF;
    block[3] = (control_code >> 8) & 0xFF;
    block[4] = channel;
    block[5] = gain;
    return TCP_write(block, size);
}

#define TCP_BUFFER_SIZE 1024
unsigned char rx_block[32];
int TCP_write(char *block, int size)
{
    static char block_to_send[TCP_BUFFER_SIZE]={0};
    static int size_to_send=0;
	int retval = 0;
	unsigned char tmp = 0;
        if((size > 0))// && (size_to_send == 0))
        {
//            block_to_send = (char *) malloc(size);
//            if(block_to_send == 0) return 1;
            if(size < TCP_BUFFER_SIZE) size_to_send = size;
            else size_to_send = TCP_BUFFER_SIZE;
            if(block != NULL) memcpy(block_to_send, block, size_to_send);
            else
            {
                size_to_send = 0;
                return 1;
            }
        }
    if(1)//w && (TCP_command_pending == 0))
    {
//        fprintf(stderr,"TCP packet -> %i (state - %i)\n\r",size,TCP_command_pending);
        if(sdr_fd != 0)
        {
                if(size_to_send != 0)
                {
                    tcp_set_pending_flag();
					retval = send(sdr_fd, block_to_send, size_to_send, 0);	
					if (retval <= 0)
					{
#ifdef _WIN32
						fprintf(stderr,"Client: send() failed: error %d.\n", WSAGetLastError());
						WSACleanup();	
#else
						fprintf(stderr,"Client: send() failed: error %d.\n", retval);
#endif
						return -1;
					}
					retval = recv(sdr_fd, rx_block, sizeof(rx_block), 0);
					if (retval <= 0)
					{
#ifdef _WIN32
						fprintf(stderr,"Client: recv() failed: error %d.\n", WSAGetLastError());
						WSACleanup();
#else
						fprintf(stderr,"Client: recv() failed: error %d.\n", retval);
#endif
						close_tcp();
						return -1;
					}
#ifdef _PRINT_DEBUG_MESSAGES_
					printf("received TCP %i bytes data: <= ", retval);
					for(int i = 0; i < retval; i++)
					{
						printf("%2.2X ", rx_block[i]);
					}
					printf("\n\r");
#endif
					tmp = rx_block[1];
					if(( tmp >> 5) == TCP_HID_PACKET)
					{
						hid_save_recieved_tcp_packet(rx_block, retval);
					}
                    size_to_send = 0;
                }
                else return 1;
          }
    }
    return 0;
}

int tcp_send_hid_command(char *block, int size)
{
    int tmp=0;
    static int busy_flag = 0;
//    if(busy_flag == 0)
    {
        busy_flag = 1;
        tmp = TCP_write(block, size);
        busy_flag = 0;
    }
    return tmp;
}

void tcp_clear_pending_flag()
{
    TCP_command_pending = 0;
}

void tcp_set_pending_flag()
{
    TCP_command_pending = 1;
}

int tcp_get_pending_flag()
{
    return TCP_command_pending;
}
//End of File

